'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

exports.deepAssign = deepAssign;

var _commonUtil = require('../utils/commonUtil');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var hasOwnProperty = Object.prototype.hasOwnProperty;


function assignKey(to, from, key) {
    var val = from[key];

    if (!(0, _commonUtil.isDef)(val)) {
        return;
    }

    if (!hasOwnProperty.call(to, key) || !(0, _commonUtil.isObj)(val) || typeof val === 'function') {
        to[key] = val;
    } else {
        // eslint-disable-next-line no-use-before-define
        to[key] = deepAssign(Object(to[key]), from[key]);
    }
}

function deepAssign(to, from) {
    (0, _keys2['default'])(from).forEach(function (key) {
        assignKey(to, from, key);
    });

    return to;
}